// Code generated by goctl. DO NOT EDIT.

package genModel

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	productRedirectConfFieldNames          = builder.RawFieldNames(&ProductRedirectConf{})
	productRedirectConfRows                = strings.Join(productRedirectConfFieldNames, ",")
	productRedirectConfRowsExpectAutoSet   = strings.Join(stringx.Remove(productRedirectConfFieldNames, "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	productRedirectConfRowsWithPlaceHolder = strings.Join(stringx.Remove(productRedirectConfFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"

	cacheCouponOpenProductRedirectConfIdPrefix = "cache:couponOpen:productRedirectConf:id:"
	cacheCouponOpenProductRedirectConfProductNoPrefixPrefix = "cache:couponOpen:productRedirectConf:product_no_prefix:"
)

type (
	productRedirectConfModel interface {
		Insert(ctx context.Context, data *ProductRedirectConf) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*ProductRedirectConf, error)
		Update(ctx context.Context, data *ProductRedirectConf) error
		Delete(ctx context.Context, id int64) error
		FindOneByProductNoPrefix(ctx context.Context, productNoPrefix string) (*ProductRedirectConf, error)
	}

	defaultProductRedirectConfModel struct {
		sqlc.CachedConn
		table string
	}

	ProductRedirectConf struct {
		Id              int64     `db:"id"`
		ProductNoPrefix string    `db:"product_no_prefix"` // 商品编号前缀
		RequestUrl      string    `db:"request_url"`       // 分发地址
		Method          string    `db:"method"`            // 请求方式
		Encrypt         uint64    `db:"encrypt"`           // 是否需要加密、加签
		CreateTime      time.Time `db:"create_time"`
	}
)

func newProductRedirectConfModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) *defaultProductRedirectConfModel {
	return &defaultProductRedirectConfModel{
		CachedConn: sqlc.NewConn(conn, c, opts...),
		table:      "`product_redirect_conf`",
	}
}

func (m *defaultProductRedirectConfModel) Delete(ctx context.Context, id int64) error {
	couponOpenProductRedirectConfIdKey := fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfIdPrefix, id)
	_, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
		return conn.ExecCtx(ctx, query, id)
	}, couponOpenProductRedirectConfIdKey)
	return err
}

func (m *defaultProductRedirectConfModel) FindOne(ctx context.Context, id int64) (*ProductRedirectConf, error) {
	couponOpenProductRedirectConfIdKey := fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfIdPrefix, id)
	var resp ProductRedirectConf
	err := m.QueryRowCtx(ctx, &resp, couponOpenProductRedirectConfIdKey, func(ctx context.Context, conn sqlx.SqlConn, v any) error {
		query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", productRedirectConfRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, id)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultProductRedirectConfModel) Insert(ctx context.Context, data *ProductRedirectConf) (sql.Result, error) {
	couponOpenProductRedirectConfIdKey := fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfIdPrefix, data.Id)
	ret, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, productRedirectConfRowsExpectAutoSet)
		return conn.ExecCtx(ctx, query, data.Id, data.ProductNoPrefix, data.RequestUrl, data.Method, data.Encrypt)
	}, couponOpenProductRedirectConfIdKey)
	return ret, err
}

func (m *defaultProductRedirectConfModel) Update(ctx context.Context, data *ProductRedirectConf) error {
	couponOpenProductRedirectConfIdKey := fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfIdPrefix, data.Id)
	_, err := m.ExecCtx(ctx, func(ctx context.Context, conn sqlx.SqlConn) (result sql.Result, err error) {
		query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, productRedirectConfRowsWithPlaceHolder)
		return conn.ExecCtx(ctx, query, data.ProductNoPrefix, data.RequestUrl, data.Method, data.Encrypt, data.Id)
	}, couponOpenProductRedirectConfIdKey)
	return err
}

func (m *defaultProductRedirectConfModel) formatPrimary(primary any) string {
	return fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfIdPrefix, primary)
}

func (m *defaultProductRedirectConfModel) queryPrimary(ctx context.Context, conn sqlx.SqlConn, v, primary any) error {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", productRedirectConfRows, m.table)
	return conn.QueryRowCtx(ctx, v, query, primary)
}

func (m *defaultProductRedirectConfModel) FindOneByProductNoPrefix(ctx context.Context, productNoPrefix string) (*ProductRedirectConf, error) {
	cacheCouponOpenProductRedirectConfProductNoPrefixPrefix := fmt.Sprintf("%s%v", cacheCouponOpenProductRedirectConfProductNoPrefixPrefix, productNoPrefix)
	var resp ProductRedirectConf
	err := m.QueryRowCtx(ctx, &resp, cacheCouponOpenProductRedirectConfProductNoPrefixPrefix, func(ctx context.Context, conn sqlx.SqlConn, v any) error {
		query := fmt.Sprintf("select %s from %s where `product_no_prefix` = ? limit 1", productRedirectConfRows, m.table)
		return conn.QueryRowCtx(ctx, v, query, productNoPrefix)
	})
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, nil
	default:
		return nil, err
	}
}

func (m *defaultProductRedirectConfModel) tableName() string {
	return m.table
}
